## org.apache.commons.collections.bidimap
Class UnmodifiableSortedBidiMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.bidimap.AbstractBidiMapDecorator
              org.apache.commons.collections.bidimap.AbstractOrderedBidiMapDecorator
                  org.apache.commons.collections.bidimap.AbstractSortedBidiMapDecorator
                      org.apache.commons.collections.bidimap.UnmodifiableSortedBidiMap

All Implemented Interfaces:
  BidiMap, IterableMap, Map, OrderedBidiMap, OrderedMap, SortedBidiMap, SortedMap, Unmodifiable

public final class UnmodifiableSortedBidiMap
extends AbstractSortedBidiMapDecorator
implements Unmodifiable

Decorates another `SortedBidiMap` to ensure it can't be altered.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.5 $ $Date: 2004/05/15 12:13:03 $
Author:
  Stephen Colebourne

Nested Class Summary

Nested classes inherited from class java.util.Map
`Map.Entry`

Field Summary

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Method Summary
`void` `clear()`
`static SortedBidiMap` `decorate(SortedBidiMap map)` Factory method to create an unmodifiable map.
`Set` `entrySet()`
`SortedMap` `headMap(Object toKey)`
`BidiMap` `inverseBidiMap()` Gets a view of this map where the keys and values are reversed.
`OrderedBidiMap` `inverseOrderedBidiMap()` Gets a view of this map where the keys and values are reversed.
`SortedBidiMap` `inverseSortedBidiMap()` Gets a view of this map where the keys and values are reversed.
`Set` `keySet()`
`MapIterator` `mapIterator()` Obtains a `MapIterator` over the map.
`OrderedMapIterator` `orderedMapIterator()` Obtains an `OrderedMapIterator` over the map.
`Object` `put(Object key, Object value)` Puts the key-value pair into the map, replacing any previous pair.
`void` `putAll(Map mapToCopy)`
`Object` `remove(Object key)`
`Object` `removeValue(Object value)` Removes the key-value pair that is currently mapped to the specified value (optional operation).
`SortedMap` `subMap(Object fromKey, Object toKey)`
`SortedMap` `tailMap(Object fromKey)`
`Collection` `values()`

Methods inherited from class org.apache.commons.collections.bidimap.AbstractSortedBidiMapDecorator
`comparator, getSortedBidiMap`

Methods inherited from class org.apache.commons.collections.bidimap.AbstractOrderedBidiMapDecorator
`firstKey, getOrderedBidiMap, lastKey, nextKey, previousKey`

Methods inherited from class org.apache.commons.collections.bidimap.AbstractBidiMapDecorator
`getBidiMap, getKey`

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`containsKey, containsValue, equals, get, getMap, hashCode, isEmpty, size, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.BidiMap
`getKey`

Methods inherited from interface java.util.Map
`containsKey, containsValue, equals, get, hashCode, isEmpty, size`

Methods inherited from interface org.apache.commons.collections.OrderedMap
`firstKey, lastKey, nextKey, previousKey`

Methods inherited from interface java.util.SortedMap
`firstKey, lastKey`

Method Detail

### decorate

    public static SortedBidiMap decorate(SortedBidiMap map)

  Factory method to create an unmodifiable map.

  If the map passed in is already unmodifiable, it is returned.

  Parameters:
    `map` - the map to decorate, must not be null
  Returns:
    an unmodifiable SortedBidiMap
  Throws:
    `IllegalArgumentException` - if map is null

### clear

    public void clear()

  Specified by:
    `clear` in interface `Map`
  Overrides:
    `clear` in class `AbstractMapDecorator`

### put

    public Object put(Object key,
                      Object value)

  Description copied from interface: `BidiMap`
  Puts the key-value pair into the map, replacing any previous pair.

  When adding a key-value pair, the value may already exist in the map against a different key. That mapping is removed, to ensure that the value only occurs once in the inverse map.

        BidiMap map1 = new DualHashBidiMap();
        map.put("A","B");  // contains A mapped to B, as per Map
        map.put("A","C");  // contains A mapped to C, as per Map

        BidiMap map2 = new DualHashBidiMap();
        map.put("A","B");  // contains A mapped to B, as per Map
        map.put("C","B");  // contains C mapped to B, key A is removed

  Specified by:
    `put` in interface `BidiMap`
  Overrides:
    `put` in class `AbstractMapDecorator`

### putAll

    public void putAll(Map mapToCopy)

  Specified by:
    `putAll` in interface `Map`
  Overrides:
    `putAll` in class `AbstractMapDecorator`

### remove

    public Object remove(Object key)

  Specified by:
    `remove` in interface `Map`
  Overrides:
    `remove` in class `AbstractMapDecorator`

### entrySet

    public Set entrySet()

  Specified by:
    `entrySet` in interface `Map`
  Overrides:
    `entrySet` in class `AbstractMapDecorator`

### keySet

    public Set keySet()

  Specified by:
    `keySet` in interface `Map`
  Overrides:
    `keySet` in class `AbstractMapDecorator`

### values

    public Collection values()

  Specified by:
    `values` in interface `Map`
  Overrides:
    `values` in class `AbstractMapDecorator`

### removeValue

    public Object removeValue(Object value)

  Description copied from interface: `BidiMap`
  Removes the key-value pair that is currently mapped to the specified value (optional operation).

  If the value is not contained in the map, `null` is returned.

  Implementations should seek to make this method perform equally as well as `remove(Object)`.

  Specified by:
    `removeValue` in interface `BidiMap`
  Overrides:
    `removeValue` in class `AbstractBidiMapDecorator`

### mapIterator

    public MapIterator mapIterator()

  Description copied from interface: `BidiMap`
  Obtains a `MapIterator` over the map.

  A map iterator is an efficient way of iterating over maps. It does not require that the map is stored using Map Entry objects which can increase performance.

       BidiMap map = new DualHashBidiMap();
       MapIterator it = map.mapIterator();
       while (it.hasNext()) {
         Object key = it.next();
         Object value = it.getValue();
         it.setValue("newValue");
       }

  Specified by:
    `mapIterator` in interface `BidiMap`
  Overrides:
    `mapIterator` in class `AbstractBidiMapDecorator`

### inverseBidiMap

    public BidiMap inverseBidiMap()

  Description copied from interface: `SortedBidiMap`
  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed equally.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  Implementations must return a `SortedBidiMap` instance, usually by forwarding to `inverseSortedBidiMap()`.

  Specified by:
    `inverseBidiMap` in interface `SortedBidiMap`
  Overrides:
    `inverseBidiMap` in class `AbstractBidiMapDecorator`

### orderedMapIterator

    public OrderedMapIterator orderedMapIterator()

  Description copied from interface: `OrderedMap`
  Obtains an `OrderedMapIterator` over the map.

  A ordered map iterator is an efficient way of iterating over maps in both directions.

       BidiMap map = new TreeBidiMap();
       MapIterator it = map.mapIterator();
       while (it.hasNext()) {
         Object key = it.next();
         Object value = it.getValue();
         it.setValue("newValue");
         Object previousKey = it.previous();
       }

  Specified by:
    `orderedMapIterator` in interface `OrderedMap`
  Overrides:
    `orderedMapIterator` in class `AbstractOrderedBidiMapDecorator`

### inverseOrderedBidiMap

    public OrderedBidiMap inverseOrderedBidiMap()

  Description copied from interface: `OrderedBidiMap`
  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed equally.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  Specified by:
    `inverseOrderedBidiMap` in interface `OrderedBidiMap`
  Overrides:
    `inverseOrderedBidiMap` in class `AbstractOrderedBidiMapDecorator`

### inverseSortedBidiMap

    public SortedBidiMap inverseSortedBidiMap()

  Description copied from interface: `SortedBidiMap`
  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `SortedMap`.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  The inverse map returned by `inverseBidiMap()` should be the same object as returned by this method.

  Specified by:
    `inverseSortedBidiMap` in interface `SortedBidiMap`
  Overrides:
    `inverseSortedBidiMap` in class `AbstractSortedBidiMapDecorator`

### subMap

    public SortedMap subMap(Object fromKey,
                            Object toKey)

  Specified by:
    `subMap` in interface `SortedMap`
  Overrides:
    `subMap` in class `AbstractSortedBidiMapDecorator`

### headMap

    public SortedMap headMap(Object toKey)

  Specified by:
    `headMap` in interface `SortedMap`
  Overrides:
    `headMap` in class `AbstractSortedBidiMapDecorator`

### tailMap

    public SortedMap tailMap(Object fromKey)

  Specified by:
    `tailMap` in interface `SortedMap`
  Overrides:
    `tailMap` in class `AbstractSortedBidiMapDecorator`

Copyright © 2001-2005 Apache Software Foundation. All Rights Reserved.